/*
 * This file is part of the Owl Positioning System (OwlPS).
 * OwlPS is a project of the University of Franche-Comte
 * (Université de Franche-Comté), France.
 *
 * Copyright © Université de Franche-Comté 2007-2012.
 *
 * Corresponding author: Matteo Cypriani <mcy@lm7.fr>
 *
 ***********************************************************************
 *
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software. You can use,
 * modify and/or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL:
 * http://www.cecill.info
 *
 * As a counterpart to the access to the source code and rights to copy,
 * modify and redistribute granted by the license, users are provided
 * only with a limited warranty and the software's authors, the holder
 * of the economic rights, and the successive licensors have only
 * limited liability.
 *
 * In this respect, the user's attention is drawn to the risks
 * associated with loading, using, modifying and/or developing or
 * reproducing the software by the user in light of its specific status
 * of free software, that may mean that it is complicated to manipulate,
 * and that also therefore means that it is reserved for developers and
 * experienced professionals having in-depth computer knowledge. Users
 * are therefore encouraged to load and test the software's suitability
 * as regards their requirements in conditions enabling the security of
 * their systems and/or data to be ensured and, more generally, to use
 * and operate it in the same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 ***********************************************************************
 *
 * This is the header file of libowlps-client, the library that contains
 * the code used to send positioning requests (normal, calibration and
 * autocalibration).
 */


#ifndef _LIBOWLPS_CLIENT_
#define _LIBOWLPS_CLIENT_

#include <owlps.h>


/* Function headers */
int owl_create_trx_socket(const char *const dest_ip,
                          const uint_fast16_t dest_port,
                          struct sockaddr_in *const server,
                          const char *const iface) ;
void owl_use_iface(const int sockfd, const char *const iface) ;
void owl_send_request(const int sockfd,
                      const struct sockaddr_in *const server,
                      const void *const packet,
                      const uint_fast16_t packet_size,
                      const uint_fast16_t nb_pkt,
                      const uint_fast32_t delay) ;
void owl_send_packet(const int sockfd,
                     const struct sockaddr_in *const server,
                     const void *const packet,
                     const uint_fast16_t packet_size) ;


#endif // _LIBOWLPS_CLIENT_
