/*
 * This file is part of the Owl Positioning System (OwlPS).
 * OwlPS is a project of the University of Franche-Comte
 * (Université de Franche-Comté), France.
 *
 * Copyright © Université de Franche-Comté 2007-2012.
 *
 * Corresponding author: Matteo Cypriani <mcy@lm7.fr>
 *
 ***********************************************************************
 *
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software. You can use,
 * modify and/or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL:
 * http://www.cecill.info
 *
 * As a counterpart to the access to the source code and rights to copy,
 * modify and redistribute granted by the license, users are provided
 * only with a limited warranty and the software's authors, the holder
 * of the economic rights, and the successive licensors have only
 * limited liability.
 *
 * In this respect, the user's attention is drawn to the risks
 * associated with loading, using, modifying and/or developing or
 * reproducing the software by the user in light of its specific status
 * of free software, that may mean that it is complicated to manipulate,
 * and that also therefore means that it is reserved for developers and
 * experienced professionals having in-depth computer knowledge. Users
 * are therefore encouraged to load and test the software's suitability
 * as regards their requirements in conditions enabling the security of
 * their systems and/or data to be ensured and, more generally, to use
 * and operate it in the same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 ***********************************************************************
 */


#ifndef _OWLPS_POSITIONING_OUTPUT_HH_
#define _OWLPS_POSITIONING_OUTPUT_HH_

class OutputMedium ;
class ResultList ;

#include <vector>

/// Handles the outputs
class Output
{
protected:
  /// List of output media used
  std::vector<OutputMedium*> output_media ;

  /** @name Operations */
  //@{
  void initialise_output_media(void) ;
  void initialise_output_terminal(void) ;
  void initialise_output_csv(void) ;
  void initialise_output_udp_socket(void) ;
  void initialise_output_tcpevaal_socket(void) ;
  //@}

public:
  Output(void) ;

  ~Output(void) ;

  /** @name Operations */
  //@{
  void write(const ResultList &results) const ;
  //@}
} ;

#endif // _OWLPS_POSITIONING_OUTPUT_HH_
